Fix some regexps in xfstests
[xfstests-dev.git] / 012
1 #! /bin/sh
2 # XFS QA Test No. 012
3 #
4 # holes
5 #
6 #-----------------------------------------------------------------------
7 # Copyright (c) 2000-2001 Silicon Graphics, Inc.  All Rights Reserved.
8
9 # This program is free software; you can redistribute it and/or modify it
10 # under the terms of version 2 of the GNU General Public License as
11 # published by the Free Software Foundation.
12
13 # This program is distributed in the hope that it would be useful, but
14 # WITHOUT ANY WARRANTY; without even the implied warranty of
15 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
16
17 # Further, this software is distributed without any warranty that it is
18 # free of the rightful claim of any third person regarding infringement
19 # or the like.  Any license provided herein, whether implied or
20 # otherwise, applies only to this software file.  Patent licenses, if
21 # any, provided herein do not apply to combinations of this program with
22 # other software, or any other product whatsoever.
23
24 # You should have received a copy of the GNU General Public License along
25 # with this program; if not, write the Free Software Foundation, Inc., 59
26 # Temple Place - Suite 330, Boston MA 02111-1307, USA.
27
28 # Contact information: Silicon Graphics, Inc., 1600 Amphitheatre Pkwy,
29 # Mountain View, CA  94043, or:
30
31 # http://www.sgi.com 
32
33 # For further information regarding this notice, see: 
34
35 # http://oss.sgi.com/projects/GenInfo/SGIGPLNoticeExplan/
36 #-----------------------------------------------------------------------
37 #
38 # creator
39 owner=dxm@sgi.com
40
41 seq=`basename $0`
42 echo "QA output created by $seq"
43
44 here=`pwd`
45 tmp=/tmp/$$
46 status=0        # success is the default!
47 trap "rm -f $tmp.*; _cleanup; exit \$status" 0 1 2 3 15
48
49 _cleanup()
50 {
51     rm -rf $TEST_DIR/holes.$$.*
52 }
53
54 _filesize()
55 {
56     ls -l $1 | $AWK_PROG '{print "    filesize = " $5}'
57 }
58
59 # get standard environment, filters and checks
60 . ./common.rc
61 . ./common.filter
62
63 _do_test()
64 {
65     _n="$1"
66     _param="$2"
67     _count="$3"
68     
69     failed=0
70     
71     out=$TEST_DIR/holes.$$.$_n
72     echo ""
73     echo "holes.$_n : $_param"
74     echo "-----------------------------------------------"
75     if  ! $here/src/holes $_param $out >$tmp.out
76     then
77         echo "    holes returned $? - see $seq.out.full"
78         failed=1
79         status=1
80     fi
81         
82
83     if [ $failed -eq 0 ]
84     then        
85         # quick check - how many holes did we get?
86         count=`xfs_bmap $out | egrep -c ': hole'`
87         echo "    $count hole(s) detected"
88         # and how big was the file?
89         _filesize $out
90         
91         if [ $count -ne $_count ]
92         then
93             echo "    unexpected number of holes - see $seq.out.full"
94             status=1
95             failed=1
96         fi
97     fi
98         
99     if [ $failed -eq 1 ]
100     then
101         echo "--------------------------------------"       >>$here/$seq.out.full
102         echo "$_n - output from holes:"                     >>$here/$seq.out.full
103         echo "--------------------------------------"       >>$here/$seq.out.full
104         cat $tmp.out                                        >>$here/$seq.out.full
105         echo "--------------------------------------"       >>$here/$seq.out.full
106         echo "$_n - output from bmap:"                      >>$here/$seq.out.full
107         echo "--------------------------------------"       >>$here/$seq.out.full
108         xfs_bmap -vvv $out                                  >>$here/$seq.out.full
109         echo "--------------------------------------"       >>$here/$seq.out.full
110         echo "$_n - output from ls -li:"                    >>$here/$seq.out.full
111         echo "--------------------------------------"       >>$here/$seq.out.full
112         ls -li $out                                         >>$here/$seq.out.full
113         status=1
114     fi
115 }
116
117 # real QA test starts here
118
119 rm -f $here/$seq.out.full
120
121 # small & fairly dense
122 _do_test 1 "-l 40960000 -b 40960 -i 10 -c 1" 100
123
124 # big & sparse
125 _do_test 2 "-l 409600000 -b 40960 -i 1000 -c 1" 10
126
127 # no holes, but a very nasty way to write a file (lots of extents)
128 _do_test 3 "-l 40960000 -b 40960 -i 10 -c 10" 0
129
130 exit